// Copyright 2019 Antrea Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"time"

	v1beta1 "github.com/vmware-tanzu/antrea/pkg/apis/clusterinformation/v1beta1"
	scheme "github.com/vmware-tanzu/antrea/pkg/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// AntreaControllerInfosGetter has a method to return a AntreaControllerInfoInterface.
// A group's client should implement this interface.
type AntreaControllerInfosGetter interface {
	AntreaControllerInfos() AntreaControllerInfoInterface
}

// AntreaControllerInfoInterface has methods to work with AntreaControllerInfo resources.
type AntreaControllerInfoInterface interface {
	Create(*v1beta1.AntreaControllerInfo) (*v1beta1.AntreaControllerInfo, error)
	Update(*v1beta1.AntreaControllerInfo) (*v1beta1.AntreaControllerInfo, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1beta1.AntreaControllerInfo, error)
	List(opts v1.ListOptions) (*v1beta1.AntreaControllerInfoList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.AntreaControllerInfo, err error)
	AntreaControllerInfoExpansion
}

// antreaControllerInfos implements AntreaControllerInfoInterface
type antreaControllerInfos struct {
	client rest.Interface
}

// newAntreaControllerInfos returns a AntreaControllerInfos
func newAntreaControllerInfos(c *ClusterinformationV1beta1Client) *antreaControllerInfos {
	return &antreaControllerInfos{
		client: c.RESTClient(),
	}
}

// Get takes name of the antreaControllerInfo, and returns the corresponding antreaControllerInfo object, and an error if there is any.
func (c *antreaControllerInfos) Get(name string, options v1.GetOptions) (result *v1beta1.AntreaControllerInfo, err error) {
	result = &v1beta1.AntreaControllerInfo{}
	err = c.client.Get().
		Resource("antreacontrollerinfos").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of AntreaControllerInfos that match those selectors.
func (c *antreaControllerInfos) List(opts v1.ListOptions) (result *v1beta1.AntreaControllerInfoList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1beta1.AntreaControllerInfoList{}
	err = c.client.Get().
		Resource("antreacontrollerinfos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested antreaControllerInfos.
func (c *antreaControllerInfos) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("antreacontrollerinfos").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a antreaControllerInfo and creates it.  Returns the server's representation of the antreaControllerInfo, and an error, if there is any.
func (c *antreaControllerInfos) Create(antreaControllerInfo *v1beta1.AntreaControllerInfo) (result *v1beta1.AntreaControllerInfo, err error) {
	result = &v1beta1.AntreaControllerInfo{}
	err = c.client.Post().
		Resource("antreacontrollerinfos").
		Body(antreaControllerInfo).
		Do().
		Into(result)
	return
}

// Update takes the representation of a antreaControllerInfo and updates it. Returns the server's representation of the antreaControllerInfo, and an error, if there is any.
func (c *antreaControllerInfos) Update(antreaControllerInfo *v1beta1.AntreaControllerInfo) (result *v1beta1.AntreaControllerInfo, err error) {
	result = &v1beta1.AntreaControllerInfo{}
	err = c.client.Put().
		Resource("antreacontrollerinfos").
		Name(antreaControllerInfo.Name).
		Body(antreaControllerInfo).
		Do().
		Into(result)
	return
}

// Delete takes name of the antreaControllerInfo and deletes it. Returns an error if one occurs.
func (c *antreaControllerInfos) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("antreacontrollerinfos").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *antreaControllerInfos) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("antreacontrollerinfos").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched antreaControllerInfo.
func (c *antreaControllerInfos) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1beta1.AntreaControllerInfo, err error) {
	result = &v1beta1.AntreaControllerInfo{}
	err = c.client.Patch(pt).
		Resource("antreacontrollerinfos").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
